/*
 * Created on 11.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package sibiriaGame;

/**
 * A class representing a digital persona known as a chat bot. 
 * The chat bot can start conversations and reply to remarks. 
 * <p> Used in AIJP assignments 1 and 2.</p>
 * slightly changed from the version of assignment 1.(can't initialize speech)
 * 
 * @author Vera Demberg
 */
public class ChatBot {

	/**
     * The name of the character
     */    
    private String name;

    /**
     * A textual description of the appearance and personality of this character
     */
    private String description;
    
    /**
     * An object of type TemplateLanguageGenerator
     */
    private TemplateLanguageGenerator tlg;
    

    /**
     * Create a ChatBot, initialise the language generator
     *
     */
    public ChatBot(String name, String description) {
        setDescription(description);
        setName(name);
        tlg = new TemplateLanguageGenerator();
    }

    
    
    /**
     * Generate a response to the specified remark
     * 
     * @param remark The comment which must be responded to
     * 
     * @return A sentence which represents a reply to the specified remark
     */
    public String reply(String remark) {
        
    return tlg.generateReply(remark);
    }

    /**
     * Gets the textual description of what the chat bot looks like and 
     * its personality
     * 
     * @return A textual description of the chat bot
     */
    public String getDescription() {
    return description;
    }

    /**
     * Gets the name of the chat bot
     * 
     * @return The name of this digital persona
     */
    public String getName() {
    return name;
    }

    /**
     * Sets up the textual description of the chat bot's appearance and personality
     * 
     * @param string The textual description of the bot
     */
    public void setDescription(String string) {
    description = string;
    }

    /**
     * Sets up the name of this digital persona
     * 
     * @param string The name of the bot
     */
    public void setName(String string) {
    name = string;  
    }
    
    protected TemplateLanguageGenerator getTLG(){
    	return tlg;
    }

}

