/*
 * Created on 11.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package sibiriaGame;

/**
 * This class is the main class of the "Travelling in Sibiria" application. 
 * "Travelling in Sibiria" is a very simple, text based adventure game.  
 *
 * This class holds information about a command that was issued by the user.
 * A command currently consists of two strings: a command word and a rest
 *  (for example, if the command was "take shoe", then the two strings
 * obviously are "take" and "shoe", or else if the command was "talk X bla bla bla", 
 * the two strings are "talk" and "X bla bla bla").
 *
 * If the command had only one word, then the second word is <null>.
 * 
 * @author  Michael Kolling and David J. Barnes
 * @author Vera Demberg, December 2004
 * @version 1.0 (February 2002)
 */

class Command
{
    private String commandWord;
    private String rest;

    /**
     * Create a command object. First and second word must be supplied, but
     * either one (or both) can be null. The command word should be null to
     * indicate that this was a command that is not recognised by this game.
     */
    public Command(String firstWord, String rest)
    {
        commandWord = firstWord;
        this.rest = rest;
    }

    /**
     * Return the command word (the first word) of this command. If the
     * command was not understood, the result is null.
     */
    public String getCommandWord()
    {
        return commandWord;
    }

    /**
     * Return the rest of this command. Returns null if there was no
     * second word.
     */
    public String getArgument()
    {
        return rest;
    }

 

    /**
     * Return true if the command has a second word.
     */
    public boolean hasSecondWord()
    {
        return (rest != null);
    }
}

