/*
 * Created on 11.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package sibiriaGame;


/**
 * This class is part of the "Travelling in Sibiria" application.
 * It represents the items that a player can possess /find/ aquire in the game.
 * each item has a description, and may havea price  for tourists and a real price, 
 * and stores a set of the actions that are available for it.
 * Items of these class can be eaten.
 * has direct subclass DrinkableItem
 * 
 * @author vera Demberg
 * @version 1.0 (December 2004)
 */
public class ConsumableItem extends Item {

 
	/**
	 * set the description for this item and add a typical action for it
	 * @param description
	 */
	public ConsumableItem(String description) {
		super(description);
		setPossAct("eat");//eat is typical action for items of class ConsumableItem

		
	}
	
	/**
	 * kind of flag for drinkability, overridden by subclass DrinkableItem
	 * @return false; consumable items are not drinkable
	 */
	public boolean drinkable(){
		return false;
	}
	
	
	/**
	 * most important method: player eats item, 
	 * item vanishes from set of items that player possessed
	 * hunger is decreased
	 * 
	 * @param player to change its attributes hunger and remove item from its carried/worn things
	 * @param room /not used in this class, but in overriding action from FreezableItem
	 * @return a confirmation
	 */
	public String consume(Player player,Room room){
		player.setHunger(-5);//decrease hunger
		player.remove(getDescription());//remove item from player
		return ("You ate "+ getDescription() + ".");
	}
}
