/*
 * Created on 11.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package sibiriaGame;


import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * This class is part of the adventure game "Travelling in Sibiria".
 * It is used by in the userInterface and prevents the user from opening new dialog windows every time talk_to_person is pressed
 * so that if he forgets to close the window after talking, there will not be loads of open dialog windows at the end of the game.
 * creates a window that pops up when action button talk_to_person is pressed
	 * This window displays a question: "What do you want to say?"
	 * a input textfield in which the user can insert free text with a button next to it to convey the text to the game
	 * and a button on the bottom of the window to close the window
	 * This window allows more fluent chatting to the characters because talk X does not have to be inserted every time.
 **/

public class DialogWindow extends JFrame {
		JPanel mainDialogPanel;//main container
		GameEngine engine;
		public DialogWindow(GameEngine engine){
			
			super("Dialog Window");	//construct it and give title 
			this.engine = engine;
			buildDialog();//main method for construction of this window
			pack();
			
			
		}

		/**
		 * invokes the method responsible for the creation of the different components of the window
		 */
		private void buildDialog() {			
			getContentPane().setLayout(new BorderLayout());	
			buildLabel();// label that will be filled with the question "What do you want to say?"
			buildConfirmButton();//button that is responsible to close the dialogwindow afterwards				
			buildTextInput();//	field where the player can insert text and button next to it			
		}
		
		/**
		 * create a label with the question "What do you want to say?"
		 * and put it to the top of the window
		 */
		private void buildLabel() {
			JLabel label = new JLabel("What do you want to say?");
			getContentPane().add(label,BorderLayout.NORTH);				
		}

		/**
		 * create the "close_dialogue"-button and 
		 * put it to the bottom of the window
		 */
		private void buildConfirmButton() {
			JButton cbutton = new JButton("close_dialogue");//create button and give it the label that will be displayed on it
			JPanel buttondesign = new JPanel();//additional container so that the button is not as long as the inputfield
			//buttondesign.setLayout(new FlowLayout());//not necessary, because default
			buttondesign.add(cbutton);//add the button to this container
			getContentPane().add(buttondesign,BorderLayout.SOUTH);//and the container to the bottom of the window
			cbutton.addActionListener(new ActionListener(){

    			public void actionPerformed(ActionEvent e) {
    				engine.interpretCommand("talk " + ((Person)engine.getCurrent().getPerson()).getName() + " "+ e.getActionCommand());
    				//only used by the game engine to give the information to the user that the dialogwindow was closed, could be omitted
    				setVisible(false);//make the window invisible
    			}
    		});
		}
		
		/**
		 * build the input text field and the button next to it
		 *
		 */
		private void buildTextInput(){
		final JTextField textfield = new JTextField(30);//create a textfield as wide as 30 characters
		JButton doso = new JButton("say it");//create a button with label "say it"
		JPanel textIn = new JPanel();//create a container in which both will be put, FlowLayout
		getContentPane().add(textIn, BorderLayout.CENTER); //the component will be displayed in the middle of the window
		textIn.add(textfield);//the textfiel will be left of the button
		textIn.add(doso);//each of the two takes a much place as needed
		textIn.getRootPane().setDefaultButton(doso);	// text can be submitted to the game engine by pressing ENTER		
		doso.addActionListener(new ActionListener(){

			public void actionPerformed(ActionEvent arg0) {
				if (! textfield.getText().equals("")){//if something has been inserted into the textfield
				engine.interpretCommand("talk " + ((Person)engine.getCurrent().getPerson()).getName() + " "+ textfield.getText());
				//send talk interlocutor utterance to the game engine (to pretend that "talk NAME bla bla" has been inserted into the inputText of the userInterface main window)
				textfield.setText("");		//clear textfield			
				}
			}
		});
		}		
	}
