/*
 * Created on 11.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package sibiriaGame;



import java.util.HashSet;
import java.util.Iterator;

/**
 * This class is part of the "Travelling in Sibiria" application.
 * It represents the items that a player can possess /find/ aquire in the game.
 * each item has a description, and may havea price  for tourists and a real price, 
 * and stores a set of the actions that are available for it.
 * has direct subclasses Money,ConsumableItem, WearableItem, Suitcase
 * 
 * @author vera Demberg
 * @version 1.0 (December 2004)
 */
public class Item {
	
	private String description;//has a description for it , for example "bike"
	private int touristPrize;//has a tourist price
	private int realPrize;//and a real price
	private boolean realPrizeAvailable = false;//whether the real price is available at the moment
	private HashSet possAct;//set of generally possible actions for that item 
	
	
	/**
	 * sets the description for the item and  creates the actions that 
	 * are generally available to all items
	 * @param description
	 */
	public Item(String description){
		this.description=description;
		possAct = new HashSet();
		setPossAct("put");
		setPossAct("take");
		setPossAct("buy");
	}
	/**
	 * removes an action from the set of possible actions for the item
	 * @param Strign action
	 */
	public void removeAction(String action){
		possAct.remove(action + " " + description);//in possAct actions are stored in the form e.g. "put camera" 
	}

	/**
	 * set real and tourist price, takes as an input the real price of which it then
	 * calculates the tourist price
	 * @param prize in currency
	 */
	public void setPrize(int prize){
		this.realPrize = prize;
		this.touristPrize = 3*prize;//tourist price 3 times higher than real price. 
	}
	
	/**
	 * 
	 * @param player
	 * @param room
	 * @return
	 */
	public String isItem(){
		return "item";
	}
	
	/**
	 * more specialized items can be consumed.
	 * overridden by consumableItem and WearableItem classes
	 * @param player
	 * @param room
	 * @return a string saying that in general items are not consumable.
	 */
	public String consume(Player player,Room room){
		return "This item is not consumable";	
	}
	

	
	//***************************various accessor and mutator methods************
	/**
	 * 
	 * @return a more elaborate string that enumerates all the actions that are available for this item
	 */
	public String getPossActDescr(){
		Iterator iter = possAct.iterator();
		String actiondescr= "possible actions for this item are (please use input line): ";
		while (iter.hasNext()){
			actiondescr = actiondescr + "\n" + iter.next();
		}
		return actiondescr;
	}
	
	/**
	 * add a new action to the actual item
	 * @param String action 
	 */
	public void setPossAct(String action){

		possAct.add(action+" "+description);
	}
	
	/**
	 * 
	 * @return a set of possible actions for the item
	 */
	protected HashSet getPossAct(){
		return possAct;
	}

	/**
	 * @return whether the tourist price is available
	 */
	public boolean isRealPrizeAvailable() {
		
		return realPrizeAvailable;
	}
	/**
	 * 
	 * @return the description of the item
	 */
	public String getDescription(){
		return description;
	}
	
	/**
	 * 
	 * @return int: the real price for the item
	 */
	public int getRealPrize(){
		return realPrize;
	}
	/**
	 * 
	 * @return int: the tourist price for the item
	 */
	public int getTouristPrize(){
		return touristPrize;
	}
	
	
}
