/*
 * Created on 11.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package sibiriaGame;


import java.util.ArrayList;
import java.util.List;
import java.util.Random;
import java.util.HashMap;

/**
* A simple template driven language generator. Used in AIJP assignment 
* 1 to generate language for the ChatBots 
* slightly modified for AIJP assignment 2
* 
* @author Judy Robertson
* @author Vera Demberg
*/
public class TemplateLanguageGenerator implements LanguageGenerator {

  /**
   * A random number field, used for all random numbers required in this class.
   */
  private Random randomReplyNumber = new Random();
  
  /**
   * A collection of word types (in this case noun, verb, adjective) 
   * which helps in making the programme more modularized
   * Less repeated code is necessary, because operations can be made 
   * iterating over Listelements instead of enumerating them.
   */
  private List wordTypes = new ArrayList();
  
  /**
   * A collection of sentence templates which this language generator can use
   */
  private List sentenceList = new ArrayList();
  
  private HashMap keywordreactions = new HashMap();

  private ArrayList SalientWords= new ArrayList();//new arraylist for ma2. stores the last two keywords used

  
  /**
   * Creates a TemplateLanguageGenerator, sets up the sentence templates,
   * sets up the word type list.
   */
  public TemplateLanguageGenerator() {  
      SalientWords.add(0,"noRememberedKeyword");//empty memory , here: memory only 2 sentences back
      SalientWords.add(1,"noRememberedKeyword");
  }
  
  /**
   * accessor method for the remembered words
   * @return an arraylist of the last mentioned keywords
   */
  public ArrayList getSalientWords(){
  	
		return SalientWords;
  	
  }
  


  
  /**
   * Provide a method to set up the sentence templates 
   * which can be used by this language generator
   *
   */
  public void populateSentences(String type, String sentence) {
  	
  	SentenceTemplate template = new SentenceTemplate(type, sentence);
		sentenceList.add(template);
      
  }
  
 

  /**
   * Generates a sentence using a randomly chosen template
   *
   * @return A string containing the sentence
   */
  public String generateSentence() {
      int index = randomReplyNumber.nextInt(sentenceList.size());//index is a random number in the relevant range
      SentenceTemplate senttemp = (SentenceTemplate) sentenceList.get(index);//take random sentencetemplate
      return senttemp.getTemplate();
	  }
  

  
  /**
   * Concatenates Strings stored in an array to one String in the order in which 
   * they occur in the array. 
   *
   * @param worda (short for wordarray) of the strings that are to be concatenated
   * 
   * @return A string concatenation of stringarrayelements
   */
  private String stringconcat (String[] worda){
      String out= "";
      for (int i=0; i<worda.length; i++){//for all Strings that are elements of inputarray
          out= out.concat(worda[i]);//concatenate them to one sentence
      }
      return out;          
  }
  


 
      
  /**
   * Use key word matching to generate a canned response to the specified
   * comment. Thereby remember the keyword used if there was one.
   * If no keyword was found, generate a sentence from a sentence template.
   * 
   * @param remark The input which we must respond to
   * 
   * @return A string containing a reply to the specified remark
   */
  private String keyWordMatch(String remark){
  	remark = cutInterpunctuation(remark);
      String[] words = remark.split(" ");//split sentence into words
      //keywordreactions is a list of keywords and the reactions to them  
      
      for (int i=0; i<words.length; i++){//iterates over all words
          if (keywordreactions.containsKey(words[i]))//if word is a keyword
          {	
          	SalientWords.set(1,SalientWords.get(0));//last remembered word is moved to second position
          	SalientWords.set(0,words[i]);//remember actual keyword
          	          	
          	return (String) keywordreactions.get(words[i]);//return the sentence
          }       
      }
//    in case no keyword was in the remark
      int index = randomReplyNumber.nextInt(sentenceList.size());
      SentenceTemplate senttemp = (SentenceTemplate) sentenceList.get(index);//get random SentenceTemplate
      String sentence = (String) senttemp.getTemplate();//get the second string, that is the sentencetemplate (first is sentence type)
      return sentence;
      
      	
  }
       
  
  /**
   * Can add a new keyword and answer to the set of keywordanswers
   * 
   * @return A HashMap containing keywords of type String as its keys and canned text of type String as values
   */
  public HashMap keyWordListConstructor(String keyword, String answer){
      
      keywordreactions.put(keyword,answer);
      return keywordreactions;
  }

  /**
   * Parse the input remark, and find a key word which we can respond to
   * 
   * @param remark The input to be parsed
   * 
   * @return A or more keyword(s) from the input which will be used in the reply
   *  
  private HashMap findKeyWord(String remark) {        
      HashMap list = new HashMap(); 
      cutInterpunctuation(remark);
      // next four lines: cut off last puctuation mark
      int l= remark.length(); //get index of last character in remark
      String s = remark.substring(l-1); //get this character (here as a String)       
      if(s.matches("\\.")|| s.matches("\\?")|| s.matches("!")){//only if it's a punctuation mark, I don't want to destroy words
      remark = remark.substring(0,l-1);}//cut it off
      
      String[] words = remark.split(" ");//split sentence into words
      int i =0;
      while (i<=words.length){//iterate over all words 
          list.put(whichType(words[i]),words[i]);//make a list of Hashmaps containing wordtype and word
          i++;
      }
      return list;//return this Hashmap   
  }
  
  
  /**
   * If there is one, cut off the interpuntuation mark at the end of the sentence,
   * @param remark
   * @return
   */
  private String cutInterpunctuation(String remark){
//  	 next four lines: cut off last puctuation mark
      int l= remark.length(); //get index of last character in remark
      String s = remark.substring(l-1); //get this character (here as a String)       
      if(s.matches("\\.")|| s.matches("\\?")|| s.matches("!")){//only if it's a punctuation mark, I don't want to destroy words
      remark = remark.substring(0,l-1);}//cut it off
      return remark;
  }
  


  

  /**
   * Generate a reply to the specified remark. The reply is related to the 
   * input remark in the vague sense that it contains a word relating to one 
   * of the words in the input
   * 
   * @param remark The remark which must be responded to
   * 
   * @return A string containing a response to the specified remark
   */    
  public String generateReply(String remark) {    
  		
          return (keyWordMatch(remark));//match keyword, look for something else to answer, if there is no keyword contained.
     
          
        
  }
}

